local socket = require "socket"
net = {}
net.id = math.random(99999) --THIS SHOULD NOT BE KEPT AS THIS VALUE

function netConnect(address, port, updaterate)
  udp = socket.udp()
  udp:settimeout(0)
  udp:setpeername(address, port)
  net.urate = updaterate
  net.t = updaterate
end

function netUpdate(dt)
  net.t = net.t - 1*dt

  if net.t < 0 then
    repeat
      data, msg = udp:receive()

      if data then
        print("We've got a message!" .. data)
        ent, cmd, parms = data:match("^(%S*) (%S*) (.*)")
        --love.window.showMessageBox("NETWORK MESSAGE RECEIVED","Entity is "..ent..", command is "..cmd.." with parameters ("..parms..")")

        param = atComma(parms, ",")

        if ent == pl.name then
          if cmd == "queueID" and pl.status == "search" then
            queueID = param[1]
          elseif cmd == "queueUpdate" and pl.status == "search" then
            pl.status = "game"
            game.id = param[1]
            music["search"]:stop()
            love.audio.play(sfx["start"])
            --love.audio.play(music["play"])
            searchTimeLeft = 0
          elseif cmd == "update" and pl.status == "game" then
            if game.status == "play" and param[1] == "count" then love.audio.play(sfx["start"]) end
            if game.status ~= "victory" and game.status ~= "defeat" then
              game.status = param[1]
            end
            game.timer = tonumber(param[2])
            if game.timer > 2 then game.timer = 2 end
            game.p1name = param[3]
            game.p2name = param[4]
            game.p1rank = getRank(tonumber(param[5]))
            game.p2rank = getRank(tonumber(param[6]))
            game.p1score = tonumber(param[7])
            game.p2score = tonumber(param[8])

            if game.p2name == "bot" then game.p2rank = game.p1rank end --bots always have the same rank as the player that they're up against

            if game.me == 1 then --to prevent rubber banding and help with smoothing
              p1d = 1000
              p2d = 0
            elseif game.me == 2 then
              p1d = 0
              p2d = 1000
            else
              p1d = 0
              p2d = 0
            end

            if distanceFrom(3,game["p1y"],3,tonumber(param[9])) > p1d then
              game.p1y = tonumber(param[9])
            end
            if distanceFrom(308,game["p1y"],308,tonumber(param[10])) > p2d then --temporarily set to 0
              game.p2y = tonumber(param[10])
            end
            if distanceFrom(game.ballx, game.bally, tonumber(param[11]),tonumber(param[12])) > 4 then

              game.ballx = tonumber(param[11])
              game.bally = tonumber(param[12])

            end
            if game.status == "play" then
              game.py = tonumber(param[9])
            end
            game.rx = tonumber(param[11])
            game.ry = tonumber(param[12])
            game.ballxv = tonumber(param[13])
            game.ballyv = tonumber(param[14])
          end
        end
      elseif cmd == "login" and pl.status == "logging" then
        if param[1] == "true" then
          pl.name = login.username
          pl.status = "menu"
        else
          pl.status = "login"
        end
      elseif cmd == "acc" then
        pl.stars = tonumber(param[1])
        pl.gd = tonumber(param[3])
        motd = param[2]
      elseif msg ~= 'timeout' then
          pl.status = "netError"
          --error("Network error: "..tostring(msg))
      end

    until not data

    net.t = 0.1
  end
end

function netSend(cmd, var1)

  local dg = string.format("%s %s %s", net.id, cmd, var1)
  udp:send(dg)
end

function setUpdateRate(newupdaterate)
  net.urate = updaterate
  net.t = updaterate
end

function setID(newid)
  net.id = newid
end
