game = {}
game.ballx = 160
game.bally = 90
game.rx = 160
game.ry = 90
game.ballxv = 0
game.ballyv = 0
game.p1y = 100
game.py = 100
game.p2y = 100
game.p1name = "Player1"
game.p2name = "Player2"
game.p1rank = "Bronze I"
game.p2rank = "Bronze I"
game.p1score = 0
game.p2score = 0
game.me = -1
game.updateTime = 0.0625

game.ballTrail = {}
game.ballTrailTimer = 0.1

function drawGame() --TODO: make this modular so we can do pretty things
  love.graphics.draw(midImg,159,0)


  for i,v in ipairs(game.ballTrail) do
    love.graphics.setColor(((math.abs(game.ballxv))/400)*255,0,0,game.ballTrail[i].alpha)
    love.graphics.rectangle("fill",game.ballTrail[i].x,game.ballTrail[i].y,5,5)
  end
  love.graphics.setColor(255,255,255)
  love.graphics.rectangle("fill",game.ballx,game.bally,5,5)

  love.graphics.setFont(textFont)
  love.graphics.printf(game.p1name.."\n"..game.p1rank,3,4,120,"center")
  love.graphics.printf(game.p2name.."\n"..game.p2rank,320-3-120,4,120,"center")

  love.graphics.setFont(scoreFont)
  love.graphics.print(game.p1score,131,150)
  love.graphics.print(game.p2score,170,150)

  --end zone colours
  if game.me == 1 then
    love.graphics.setColor(255,100,100)
  elseif game.me == 2 then
    love.graphics.setColor(100,255,100)
  end
  love.graphics.rectangle("fill",0,0,2,180)

  if game.me == 1 then
    love.graphics.setColor(100,255,100)
  elseif game.me == 2 then
    love.graphics.setColor(255,100,100)
  end
  love.graphics.rectangle("fill",318,0,2,180)

  love.graphics.setColor(255,255,255)

  if game.me == 3 then
    love.graphics.setFont(textFont)
    love.graphics.setColor(255,0,0)
    love.graphics.print("Spectating",0,180-textFont:getHeight())
    love.graphics.setColor(255,255,255)
  end

  love.graphics.rectangle("fill",3,game.p1y,9,28)
  love.graphics.rectangle("fill",308,game.p2y,9,28)

  --love.graphics.line(game.ballx+2,game.bally+2,game.rx+2,game.ry+2)


  --victory / defeat screen
  if game.status == "count" then
    love.graphics.print(game.timer+1,160,90)
    love.graphics.rectangle("line",3,game.py,9,28)
  elseif game.status == "p1w" or game.status == "p2w" or game.status == "victory" or game.status == "defeat" then
    love.graphics.setColor(0,0,0,100)
    love.graphics.rectangle("fill",0,0,320,180)
    love.graphics.setColor(255,255,255)
    love.graphics.setFont(textFont)
    love.graphics.printf("Tap anywhere to continue...",0,160,320,"center")

    love.graphics.setFont(titleFont)
    drawStars(55,50,pl.stars)
    if game.status == "victory" then
      love.graphics.setColor(100,255,100,75)
      love.graphics.printf("VICTORY!",love.math.random(-2,2),love.math.random(18,22),320,"center")
      love.graphics.setColor(100,255,100)
      love.graphics.printf("VICTORY!",0,20,320,"center")
    elseif game.status == "defeat" then
      love.graphics.setColor(255,100,100,75)
      love.graphics.printf("DEFEAT!",love.math.random(-2,2),love.math.random(18,22),320,"center")
      love.graphics.setColor(255,100,100)
      love.graphics.printf("DEFEAT!",0,20,320,"center")
    elseif game.status == "p1w" then
      love.graphics.printf(game.p1name.." WINS!",0,20,320,"center")
    elseif game.status == "p2w" then
      love.graphics.printf(game.p2name.." WINS!",0,20,320,"center")
    end
  end

end

function updateGame(dt)
  if game.status == "play" then
    game.ballx = game.ballx + game.ballxv*dt
    game.bally = game.bally + game.ballyv*dt

    game.ballTrailTimer = game.ballTrailTimer - 1*dt
    if game.ballTrailTimer < 0 then
      local newTrail = {x = game.ballx, y = game.bally, alpha=200}
      table.insert(game.ballTrail,newTrail)
      game.ballTrailTimer = 0.001
    end

    for i,v in ipairs(game.ballTrail) do
      game.ballTrail[i].alpha = game.ballTrail[i].alpha - 555*dt
      if game.ballTrail[i].alpha < 0 then
        table.remove(game.ballTrail,i)
      end
    end

    if game.ballx < 0 or game.ballx > 320-5 then
    --  game.ballxv = -game.ballxv
    end

    if game.ballx < 12 and game.p1y < game.bally+5 and game.p1y+28 > game.bally-5 then
      bounceBall()
    elseif game.ballx > 320-12 and game.p2y < game.bally+5 and game.p2y+28 > game.bally-5 then
      bounceBall()
    end

    if game.bally > 180-5 or game.bally < 0 then
      game.ballyv = -game.ballyv
    end

    if game.me ~= 3 then

      local spd = 150*dt

      if love.keyboard.isDown(KEY_UP) then
        game["p"..game.me.."y"] = game["p"..game.me.."y"] - spd
      elseif love.keyboard.isDown(KEY_DOWN) then
        game["p"..game.me.."y"] =  game["p"..game.me.."y"] + spd
      end

      game["p"..game.me.."y"] = cy-8
    end
  end

  if game.p1name == pl.name then
      game.me = 1
    elseif game.p2name == pl.name then
      game.me = 2
    else
      game.me = 3 --spectator
    end



  game.updateTime = game.updateTime - 1*dt
  if game.updateTime < 0 and game.status ~= "p1w" and game.status ~= "p2w" and game.status ~= "victory" and game.status ~= "defeat" then
    if game["p"..game.me.."y"] then
      netSend("update", pl.name..","..game.id..","..game["p"..game.me.."y"])
    else
      netSend("update", pl.name..","..game.id..",0")
    end
    game.updateTime = 0.1
  end

  if game.status == "p1w" or game.status == "p2w" then
      if game.status == "p1w" and game.me == 1 then pl.stars = pl.stars + 1 game.status = "victory" stars.mode = "up" stars.alpha = 50 stars.scale = 15 love.audio.play(sfx["victory"]) elseif game.status == "p2w" and game.me == 1 then pl.stars = pl.stars - 1 game.status = "defeat" stars.mode = "down" stars.alpha = 255 stars.scale = 1 love.audio.play(sfx["defeat"]) end
      if game.status == "p2w" and game.me == 2 then pl.stars = pl.stars + 1 game.status = "victory" stars.mode = "up" stars.alpha = 50 stars.scale = 15 love.audio.play(sfx["victory"]) elseif game.status == "p1w" and game.me == 2 then pl.stars = pl.stars - 1 game.status = "defeat" stars.mode = "down" stars.alpha = 255 stars.scale = 1 love.audio.play(sfx["defeat"]) end
  end
end

function bounceBall()
  sfx["hit"]:stop()
  if math.abs(game.ballxv) > 200 then
    game.ballyv = game.ballyv*1.1
    game.ballxv = -game.ballxv
  else
    game.ballxv = (-game.ballxv)*1.1
  end

  game.ballx = game.ballx + (game.ballxv/10)
  love.audio.play(sfx["hit"])
end
