require "modules/ui/menu"
require "modules/ui/search"
require "modules/ui/game"
require "modules/ui/generic"
require "modules/ui/login"

local utf8 = require("utf8")

function loadFonts()
  defFont = love.graphics.newFont(8)
  titleFont = love.graphics.newFont("img/font/Pixel Digivolve.otf",24)
  textFont = love.graphics.newFont("img/font/Pixel Digivolve.otf",12)
  scoreFont = love.graphics.newFont("img/font/Pixel Digivolve.otf",28)
end

function loadImg()
  starImg = love.graphics.newImage("img/star.png")
  midImg = love.graphics.newImage("img/middle court.png")
end

function drawPhase()
  local p = pl.status

  if p == "login" then
    drawLogin()
  elseif p == "logging" then
    drawLogging()
  elseif p == "netError" then
    drawNetError()
  elseif p == "menu" then
    drawMenu()
  elseif p == "search" then
    drawSearch()
  elseif p == "game" then
    drawGame()
  end
end

function love.mousereleased(x,y,button)
  local p = pl.status

  if p == "menu" then
    if cy > 65 and cy < 95 then
      pl.status = "search"
      love.audio.play(sfx["select"])
      music["theme"]:stop()
      love.audio.play(music["search"])
      netSend("find", pl.name)
    elseif cy > 95 and cy < 130 then
      love.window.showMessageBox("Paddle League","Leaderboards will be released at the end of this season at http://peb.si/pl!")
    end
  elseif p == "login" then
    if cy > 50 and cy < 74 then login.selected = "username" love.audio.play(sfx["select"]) end
    if cy > 80 and cy < 104 then login.selected = "password" love.audio.play(sfx["select"]) end
    if cy > 110 and cy < 134 then netSend("login", login.username..","..login.pw) pl.status = "logging" love.audio.play(sfx["select"]) end
  elseif p == "game" then
    if game.status == "victory" or game.status == "defeat" or game.status == "p1w" or game.status == "p2w" then
      pl.status = "menu"
      game.status = "play"
    end
  end
end

function love.textinput(t)
  local p = pl.status

  if p == "login" then
    if login.selected == "username" then
      login.username = login.username..t
    elseif login.selected == "password" then
      login.pw = login.pw..t
    end
  end
end

function love.keypressed(key)
  local p = pl.status

  if p == "login" then
    if key == "backspace" then
        -- get the byte offset to the last UTF-8 character in the string.
        if login.selected == "username" then
          local byteoffset = utf8.offset(login.username, -1)

          if byteoffset then
              login.username = string.sub(login.username, 1, byteoffset - 1)
          end
        elseif login.selected == "password" then
          local byteoffset = utf8.offset(login.pw, -1)

          if byteoffset then
              login.pw = string.sub(login.pw, 1, byteoffset - 1)
          end
        end

    elseif key == "return" then
      if login.selected == "username" then
        login.selected = "password" love.audio.play(sfx["select"])
      elseif login.selected == "password" then
        netSend("login", login.username..","..login.pw) pl.status = "logging" love.audio.play(sfx["select"])
      end
    end
  end
end
